.ds xL AFUtillib \- C Language AF Utilities
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
.tm \\n%:\\$1:\\$2:\\$3
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de PN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH AFSingleTone 3 "Release 1" "AF Version 3" 
.SH NAME
\fBAFSingleTone\fP \- generate a tone
.SH SYNTAX
\fB#include <AF/AFUtils.h>\fP
.LP
extern double \fBAFSingleTone\fP(double \fIfreq\fP, double \fIpeak\fP, 
.br
                                        double \fIphase\fP, 
.br
                                        float \fI*buffer\fP, int \fIlength\fP);
.LP
.SH DESCRIPTION
.PN AFSingleTone
is a flexible subroutine for generating and combining sinewave
signals.  The generated signal is ADDED into the output buffer, so
the client of this procedure has the responsibility for initially
zeroing the buffer.  Multiple tones can be generated by repeated
calls.
.SH ARGUMENTS
.IP \fIfreq\fP
is the desired digital frequency, expressed as a fraction of the
sampling rate.  The value should be in the range 0.0 to 0.5.
.IP \fIpeak\fP
is the peak value of the sine wave desired.
.IP \fIphase\fP
is the initial phase desired.  This should be in the range [0.0..1024.0).
It is used as an initial index into the sine wave table AF_sine_float(3).
The return value from AFSingleTone is the final phase.  If the return
value is passed to a second invocation of AFSingleTone, the resulting
wave will be continuous at the boundary.
.IP \fIbuffer\fP
is a pointer to the signal buffer that will be filled in by AFTonePair.
.IP \fIlength\fP
is the length of the block desired.
.SH "SEE ALSO"
AF_sine_float(3), AFTonePair(3), AFDialPhone(3)
.br
AF(1)
\.SH BUGS
If you encounter a \fBreproducible\fP bug, please 
submit a problem report to (af-bugs@crl.dec.com).
.SH COPYRIGHT
Copyright 1990-1994, Digital Equipment Corporation.
.br
See \fIAF(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Larry Stewart, 
Digital Cambridge Research Lab

