.ds xL AFUtillib \- C Language AF Utilities
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
.tm \\n%:\\$1:\\$2:\\$3
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de PN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH AF_gain_table_u 3 "Release 1" "AF Version 3" 
.SH NAME
\fBAF_gain_table_u, AF_gain_table_a\fP \- ULAW and ALAW gain tables
.SH SYNTAX
\fB#include <AF/AFUtils.h>\fP
.LP
extern int AF_gain_min_u, AF_gain_max_u;
.LP
extern unsigned char *\fBAF_gain_table_u\fP[];
.LP
extern int AF_gain_min_a, AF_gain_max_a;
.LP
extern unsigned char *\fBAF_gain_table_a\fP[];
.SH DESCRIPTION
.PN AF_gain_table_u
is an array of precomputed gain tables for ULAW samples.
.PN AF_gain_table_a
is the same thing, but for ALAW samples.
These tables are useful for effectivly decompressing a sample, multiplying
by a constant, and recompressing.  The tables are available in 1 dB
steps from
.PN AF_gain_min_u
to
.PN AF_gain_max_u
for ULAW samples.
(or from
.PN AF_gain_min_a
to
.PN AF_gain_max_a
for ALAW samples.)
.SH EXAMPLES
Typical usage is:
.LP
.Ds 0
.TA .5i 3i
.ta .5i 3i
unsigned char *gain_table;
unsigned char input, output;
/* first select a particular table, for 5 dB gain */
gain_table = AF_gain_table_u[ 5 - AF_gain_min_u ];
/* now translate the sample */
output = gain_table[ input ];
.De
.SH DIAGNOSTICS
If you index the table with an out-of-range linear value you
may cause a protection fault and crash your application.
.SH "SEE ALSO"
AF(1)
.SH BUGS
If you encounter a \fBreproducible\fP bug, please 
submit a problem report to (af-bugs@crl.dec.com).
.SH COPYRIGHT
Copyright 1990-1994, Digital Equipment Corporation.
.br
See \fIAF(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Tom Levergood and Larry Stewart, 
Digital Cambridge Research Lab
