.ds xL AFUtillib \- C Language AF Utilities
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
.tm \\n%:\\$1:\\$2:\\$3
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de PN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH AF_sample_sizes 3 "Release 1" "AF Version 3" 
.SH NAME
\fBAF_sample_sizes\fP \- information about encoding types
.SH SYNTAX
\fB#include <AF/AFUtils.h>\fP
.LP
.Ds 0
.TA .5i 3i
.ta .5i 3i
 struct AFSampleTypes {
     unsigned int bytes_per_unit;    bytes per minimal block
     unsigned int samples_per_unit;  samples per minimal block
     char *name;                     name of the encoding
     }
.De
.LP
extern struct AFSampleTypes \fBAF_sample_sizes\fP[];
.SH DESCRIPTION
.PN AF_sample_sizes
is a precomputed table you can link with your application.
It is indexed by values of the type AEncodeType found in audio.h.
For each of these encoding types, 
.PN AF_sample_sizes
gives useful information.
.LP
.PN bytes_per_unit
is the block size of the encoding, while
.PN samples_per_unit
is the number of samples per block.
.PN name
is a text string, human sensible name for the encoding.
.LP
For example, a 3-bit-per-sample encoding such as a 24 Kbps ADPCM
would have bytes_per_unit == 3, samples_per_unit == 8.
.SH "SEE ALSO"
AFSilence(3), AFCreateAC(3), AFChangeAC(3)
.br
AF(1)
.SH BUGS
We realize this data structure may not be adequate to describe
variable rate or variable block size formats.
.LP
If you encounter a \fBreproducible\fP bug, please 
submit a problem report to (af-bugs@crl.dec.com).
.SH COPYRIGHT
Copyright 1990-1994, Digital Equipment Corporation.
.br
See \fIAF(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Larry Stewart, 
Digital Cambridge Research Lab
