.ds xL AFlib \- C Language AF Interface
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
.tm \\n%:\\$1:\\$2:\\$3
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de PN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH AAudioDeviceDescriptor 3 "Release 1" "AF Version 3" 
.SH NAME
\fBAAudioDeviceDescriptor\fR \- audio device attributes
.SH SYNTAX
\fB#include <AF/AFlib.h>\fP
.LP
AFDeviceDescriptor *\fBAAudioDeviceDescriptor\fP (AFAudioConn * \fIaud\fP, 
.br
                                        int \fIdev_index\fP)
.SH ARGUMENTS
.IP \fIaud\fP 1i
The handle to an audio connection as returned by \fIAFOpenAudioConn(3)\fP.
.IP \fIdev_index\fP 1i
The number of the audio device of interest.
This index must be in the range 0 to aud->ndevices-1, inclusive.
.SH DESCRIPTION
.PP
The \fIAFDeviceDescriptor\fP is a data structure containing the
attributes of an audio device and contains the fields shown here:
.LP
.Ds 0
.TA .5i 3i
.ta .5i 3i
typedef struct {
      int numberOfInputs;
      int numberOfOutputs;
      unsigned int inputsFromPhone;
      unsigned int outputsToPhone;
      unsigned int playSampleFreq;
      AEncodeType playBufType;
      unsigned int playNchannels;
      unsigned int playNSamplesBuf;
      unsigned int recSampleFreq;
      unsigned int recNchannels;
      AEncodeType recBufType;
      unsigned int recNSamplesBuf;
} AFDeviceDescriptor;
.De
.PP
The structure fields are described as follows:
.IP \fInumberOfInputs\fP 1.5i
Number of input sources for this device.
.IP \fInumberOfOutputs\fP 1.5i
Number of output destinations for this device.
.IP \fIinputsFromPhone\fP 1.5i
Bitmask of device inputs that are connected to a telephone line.
.IP \fIoutputsToPhone\fP 1.5i
Bitmask of device outputss that are connected to a telephone line.
.IP \fIplaySampleFreq\fP 1.5i
Playback sampling frequency, in samples per second.
.IP \fIplayBufType\fP 1.5i
Playback data type.
.IP \fIplayNchannels\fP 1.5i
Number of playback channels.
.IP \fIplayNSamplesBuf\fP 1.5i
Size (in samples) of server's playback buffer.
.IP \fIrecSampleFreq\fP 1.5i
Record sampling frequency, in samples per second.
.IP \fIrecNchannels\fP 1.5i
Number of record channels.
.IP \fIrecBufType\fP 1.5i
Record data type.
.IP \fIrecNSamplesBuf\fP 1.5i
Size (in samples) of server's record buffer.
.SH "SEE ALSO"
AFOpenAudioConn(3), AF(1)
.SH BUGS
If you encounter a \fBreproducible\fP bug, please 
submit a problem report to (af-bugs@crl.dec.com).
.SH COPYRIGHT
Copyright 1990-1994, Digital Equipment Corporation.
.br
See \fIAF(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Digital Cambridge Research Lab
