.ds xL AFlib \- C Language AF Interface
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
.tm \\n%:\\$1:\\$2:\\$3
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de PN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH AFCreateAC 3 "Release 1" "AF Version 3" 
.SH NAME
\fBAFCreateAC, AFChangeACAttributes, AFFreeAC\fR \- manipulate audio contexts
.SH SYNTAX
\fB#include <AF/AFlib.h>\fP
.LP
AC \fBAFCreateAC\fP (AFAudioConn \fI*aud\fP, ADevice \fIdevice\fP, unsigned long \fIvaluemask\fP, 
.br
                                        AFSetACAttributes \fI*attributes\fP)
.LP
void \fBAFChangeACAttributes\fP (AC \fIac\fP, unsigned long \fIvaluemask\fP, 
.br
                                        AFSetACAttributes \fI*attributes\fP)
.LP
void \fBAFFreeAC\fP (AC \fIac\fP)
.SH ARGUMENTS
.IP \fIaud\fP 1i
Specifies the connection to the audio server.
.IP \fIdevice\fP 1i
Specifies the index of the desired device in the device array 
as defined  when the connection to the audio server was opened.
.IP \fIac\fP 1i
Specifies an existing AC.
.IP \fIvaluemask\fP 1i
Specifies which attributes in the AC are to be set or modifed.  Its value
is a bitwise inclusive OR of zero or more valid AC component mask bits
(\fBACRecordGain\fP, \fBACPlayGain\fP, \fBACPreemption\fP, 
\fBACStartTimeout\fI, \fBACEndSilence\fP,
\fBACEncodingType\fP, \fBACChannels\fR, and \fBACEndian\fP).
.IP \fIattributes\fP 1i
Provides any values specified by the \fIvaluemask\fP.
.SH DESCRIPTION
The
.PN AFCreateAC
function returns an audio context with the attributes specified by
\fIattributes\fP.  The audio context is initialized with a play and record
gain of 0 dB, mix mode (no preempt), whatever channels and sample type are
supported by the device, and the endian-ness of the client machine.
.LP
.PN AFChangeACAttributes
changes the specified components of the given AC.
.LP
.PN AFFreeAC
destroys the given AC and any associated storage.
.SH BUGS
The client library should provide some sort of abstract
interface for obtaining the \fIdevice\fP handle.
.SH "SEE ALSO"
AFOpenAudioConn(3), AFCreatePhoneAC(3), AAudioDeviceDescriptor(3)
.br
AF(1)
.SH BUGS
If you encounter a \fBreproducible\fP bug, please 
submit a problem report to (af-bugs@crl.dec.com).
.SH COPYRIGHT
Copyright 1990-1994, Digital Equipment Corporation.
.br
See \fIAF(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Digital Cambridge Research Lab
