.ds xL AFlib \- C Language AF Interface
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de FD
.LP
.KS
.TA .5i 3i
.ta .5i 3i
.nf
..
.de FN
.fi
.KE
.LP
..
.de IN		\" send an index entry to the stderr
.tm \\n%:\\$1:\\$2:\\$3
..
.de C{
.KS
.nf
.D
.\"
.\"	choose appropriate monospace font
.\"	the imagen conditional, 480,
.\"	may be changed to L if LB is too
.\"	heavy for your eyes...
.\"
.ie "\\*(.T"480" .ft L
.el .ie "\\*(.T"300" .ft L
.el .ie "\\*(.T"202" .ft PO
.el .ie "\\*(.T"aps" .ft CW
.el .ft R
.ps \\n(PS
.ie \\n(VS>40 .vs \\n(VSu
.el .vs \\n(VSp
..
.de C}
.DE
.R
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de PN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de NT
.ne 7
.ds NO Note
.if \\n(.$>$1 .if !'\\$2'C' .ds NO \\$2
.if \\n(.$ .if !'\\$1'C' .ds NO \\$1
.ie n .sp
.el .sp 10p
.TB
.ce
\\*(NO
.ie n .sp
.el .sp 5p
.if '\\$1'C' .ce 99
.if '\\$2'C' .ce 99
.in +5n
.ll -5n
.R
..
.		\" Note End -- doug kraft 3/85
.de NE
.ce 0
.in -5n
.ll +5n
.ie n .sp
.el .sp 10p
..
.ny0
.TH AFSelectEvents 3 "Release 1" "AF Version 3" 
.SH NAME
\fBAFEnablePassThrough, AFDisablePassThrough\fP - connect local audio and phone devices
.SH SYNTAX
\fB#include <AFlib.h>\fP
.LP
void \fBAFEnablePassThrough\fP (AC \fIac\fP, ABool \fIchange\fP, ABool \fI*old_state\fP, 
.br
                                        ABool \fI*new_state\fP)
.LP
void \fBAFDisablePassThrough\fP (AC \fIac\fP, ABool \fIchange\fP, ABool \fI*old_state\fP, 
.br
                                        ABool \fI*new_state\fP)
.SH ARGUMENTS
.IP \fIac\fP 1i
Audio context of a device to use.
.IP \fIchange\fP 1i
To query the current pass-through state, set change to 0.
If change is non-zero then pass-through will be enabled and
new_state will contain 1 upon return from AFEnablePassThrough.
new_state will contain 0 and pass-through will be disabled upon
return from AFDisablePassThrough.
.IP \fInew_state\fP 1i
Returns the new state.
.IP \fIold_state\fP 1i
Returns the old state.
.SH DESCRIPTION
The
.PN AFEnablePassThrough
function directly connects the local audio device to the phone device,
so there is no software overhead in processing the audio.  While this
is enabled, audio sent to the audio device is discarded, and silence
is recorded.
.LP
.PN AFDisablePassThrough
removes this direct connection.
.LP
Note that these functions only work on interfaces that support both
a local audio device and a phone device, such as DECaudio.
.SH "SEE ALSO"
AF(1)
.br



.SH BUGS
If you encounter a \fBreproducible\fP bug, please 
submit a problem report to (af-bugs@crl.dec.com).
.SH COPYRIGHT
Copyright 1990-1994, Digital Equipment Corporation.
.br
See \fIAF(1)\fP for a full statement of rights and permissions.
.SH AUTHORS
Digital Cambridge Research Lab
