.TH Aaxp 1 "Release 1"  "AF Version 3"
.SH NAME
\fIAaxp, Amaxine, Asparc\fP - a network-transparent audio server for Alpha AXP
workstations, Personal DECstations, and SparcStations.
.SH SYNOPSIS
.PP
The AF audio server
is a network transparent  system developed at Digital CRL.
The audio servers described in this manual page support
the native 8KHz CODECs on some DEC workstations and the SparcStation.
.SH DESCRIPTION
.PP
\fIAaxp\fP is an AF server with native CODEC audio 
device dependent support for DEC3000 workstations.
.PP
\fIAmaxine\fP is an AF server with native CODEC audio 
device dependent support for DECstation 5000 model 25 workstations.
.PP
\fIAsparc\fP is an AF server with native CODEC audio 
device dependent support for SparcStations.
.SH STARTING UP
.PP
Aaxp [:\fIportOffset\fP] [\fIoptions\fP] &
.PP
Amaxine [:\fIportOffset\fP] [\fIoptions\fP] &
.PP
Asparc [:\fIportOffset\fP] [\fIoptions\fP] &
.SH OPTIONS
.TP
.B \-help
.IP 
Use the help switch to determine device independent arguments.
.SH "AUDIO DEVICES"
.PP
These audio servers present a single 8KHz input/output 
audio device to client applications.  The audio device number is \fI0\fP.
.SH "CONNECTION NAME"
.PP
From the user's prospective, every AF server has 
an \fIaudio connection\fP of the form:
.sp
.ce 1
\fIhostname:portOffset\fP
.sp
This information is used by the application to determine how it should
connect to the server.
.TP 8
.I hostname
The \fIhostname\fP specifies the name of the machine to which the 
audio device is physically connected.  
.TP 8
.I portOffset
The \fIportOffset\fP is used to identify
the audio server's port on \fIhostname\fP.
For example, to simultaneously run two audio servers on a given host,
you might select \fI0\fP or \fI1\fP for \fIportOffset\fP.
.PP
If the connection name to an audio server is not specified, 
then the environment variables \fIAUDIOFILE\fP or \fIDISPLAY\fP 
will be used.
.SH "ACCESS CONTROL"
The sample server provides two types of access control:  an authorization
protocol which provides a list of ``magic cookies'' clients can send to
request access, and a list of hosts from which connections are always
accepted.  
.SH BUGS
If you encounter a \fBrepeatable\fP bug, please 
submit a problem report to () and include the source code if possible.
.SH "SEE ALSO"
.PP
AF(1), Aaxp(1), Amaxine(1), Alofi(1), Ajv(1), Amsb(1), Aj300(1), aplay(1), arecord(1),
apass(1), aset(1), abrowse(1), afft(1), ahost(1), aphone(1), aprop(1), ahs(1),
axset(1), xpow(1), afxctl(1), aname2num(1), alsatoms(1), aevents(1), abob(1)
.SH COPYRIGHT
.PP
See the COPYRIGHTS file.
.sp
Copyright 1991-1994, Digital Equipment Corporation and
the Massachusetts Institute of Technology.
.SH AUTHORS
Digital Cambridge Research Lab

