.TH Aj300 1 "Release 1"  "AF Version 3"
.SH NAME
Aj300 - a network-transparent audio server for Digital's J300 Sound and Motion Board.
.SH SYNOPSIS
.PP
The AF audio server
is a network transparent  system developed at Digital CRL.
Aj300 permits using the J300 Sound and Motion Board audio hardware in a 
distributed environment.
.SH DESCRIPTION
.PP
Aj300 is an AF server with J300
device dependent support.
.SH STARTING UP
Aj300 [:\fIportOffset\fP] [\fIoptions\fP] &
.SH OPTIONS
.TP
.B \-help
.IP 
Use the help switch to determine device independent arguments.
.TP
.B \-device \fIdevice\fP
.IP 
Specifies the name of the J300 board audio special device file.
If this switch is not used, the \fIAj300\fP audio server will
default to the device specified by the
AUDIO_DEVICE environment variable or the \/dev\/ama0 device.
.TP
.B \-hrate <#>
.IP
Causes the server to set the audio hardware sampling rate.
The default sampling rate is 8000 Hz.  The DDA supports the following
hardware sampling rates: 8000, 11025, 16000, 22050, 
32000, 44100, and 48000 Hz rates.
.SH "AUDIO DEVICES"
.PP
The \fIAj300\fP audio server presents three audio devices to client
applications.  These audio devices map to the audio hardware
using stereo data, left channel only, and right channel only.
The sampling rate of the audio devices is set by the \fIhrate\fP
switch.  The default audio
data type is LIN16.  AF conversion services support other
datatypes.
.SH "CONNECTION NAME"
.PP
From the user's prospective, every AF server has 
an \fIaudio connection\fP of the form:
.sp
.ce 1
\fIhostname:portOffset\fP
.sp
This information is used by the application to determine how it should
connect to the server.
.TP 8
.I hostname
The \fIhostname\fP specifies the name of the machine to which the 
audio device is physically connected.  
.TP 8
.I portOffset
The \fIportOffset\fP is used to identify
the audio server's port on \fIhostname\fP.
For example, to simultaneously run two audio servers on a given host,
you might select \fI0\fP or \fI1\fP for \fIportOffset\fP.
.PP
If the connection name to an audio server is not specified, 
then the environment variables \fIAUDIOFILE\fP or \fIDISPLAY\fP 
will be used.
.SH "ACCESS CONTROL"
The sample server provides two types of access control:  an authorization
protocol which provides a list of ``magic cookies'' clients can send to
request access, and a list of hosts from which connections are always
accepted.  
.SH BUGS
If you encounter a \fBrepeatable\fP bug, please 
submit a problem report to () and include the source code if possible.
.SH "SEE ALSO"
.PP
AF(1), Aaxp(1), Amaxine(1), Alofi(1), Ajv(1), Amsb(1), Aj300(1), aplay(1), 
arecord(1),
apass(1), aset(1), abrowse(1), afft(1), ahost(1), aphone(1), aprop(1), ahs(1),
axset(1), xpow(1), afxctl(1), aname2num(1), alsatoms(1), aevents(1), abob(1)
.SH COPYRIGHT
.PP
See the COPYRIGHTS file.
.sp
Copyright 1991-1994, Digital Equipment Corporation and
the Massachusetts Institute of Technology.
.SH AUTHORS
Digital Cambridge Research Lab
