.TH Ajv 1 "Release 1"  "AF Version 3"
.SH NAME
Ajv - a network-transparent audio server for JVideo.
.SH SYNOPSIS
.PP
The AF audio server
is a network transparent  system developed at Digital CRL.
for using JVideo audio hardware in a distributed environment.
.SH DESCRIPTION
.PP
Ajv is an AF server with JVideo device dependent support.
.SH STARTING UP
Ajv [:\fIportOffset\fP] [\fIoptions\fP] &
.SH OPTIONS
.TP
.B \-help
.IP 
Use the help switch to determine device independent arguments.
.TP
.B \-device \fIdevice\fP
.IP 
Specifies the name of the JVideo  audio special device file.
If this switch is not used, the \fIAjv\fP audio server will
default to the device specified by the
AUDIO_DEVICE environment variable or the \/dev\/jva0 device.
.TP
.B \-ukernel \fIlodfile\fP
.IP
Specifies an alternate DSP56001 absolute lodfile.
If \fIukernel\fP is not specified, the server 
checks for the AF_UKERNEL environment variable.
If neither the switch nor the AF_UKERNEL environment
is used, the server looks for 
the path DIR/Ajvmain.lod
where DIR is the LODPATH environment variable if it
exists, otherise it is the config variable LODDIR.
.TP
.B \-hrate <#>
.IP
Causes the server to set the audio hardware sampling rate.
The default sampling rate is 8000 Hz.  The JVideo hardware
supports 8000, 16000, 22000, 32000, 44100, and 48000 Hz rates.
.SH "AUDIO DEVICES"
.PP
The \fIAjv\fP audio server presents three audio devices to client
applications.  These audio devices map to the audio hardware
using stereo data, left channel only, and right channel only.
The sampling rate of the audio devices is set by the \fIhrate\fP
switch.  
The supported audio data type is LIN16 for all sample rates, unlike
the Ajv server in the previous release.
.SH "CONNECTION NAME"
.PP
From the user's prospective, every AF server has 
an \fIaudio connection\fP of the form:
.sp
.ce 1
\fIhostname:portOffset\fP
.sp
This information is used by the application to determine how it should
connect to the server.
.TP 8
.I hostname
The \fIhostname\fP specifies the name of the machine to which the 
audio device is physically connected.  
.TP 8
.I portOffset
The \fIportOffset\fP is used to identify
the audio server's port on \fIhostname\fP.
For example, to simultaneously run two audio servers on a given host,
you might select \fI0\fP or \fI1\fP for \fIportOffset\fP.
.PP
If the connection name to an audio server is not specified, 
then the environment variables \fIAUDIOFILE\fP or \fIDISPLAY\fP 
will be used.
.SH "ACCESS CONTROL"
The sample server provides two types of access control:  an authorization
protocol which provides a list of ``magic cookies'' clients can send to
request access, and a list of hosts from which connections are always
accepted.  
.SH BUGS
If you encounter a \fBrepeatable\fP bug, please 
submit a problem report to af-bugs@crl.dec.com and
include the source code if possible.
.SH "SEE ALSO"
.PP
AF(1), Aaxp(1), Amaxine(1), Alofi(1), Ajv(1), Amsb(1), Aj300(1), aplay(1), arecord(1),
apass(1), aset(1), abrowse(1), afft(1), ahost(1), aphone(1), aprop(1), ahs(1),
axset(1), xpow(1), afxctl(1), aname2num(1), alsatoms(1), aevents(1), abob(1)
.SH COPYRIGHT
.PP
See the COPYRIGHTS file.
.sp
Copyright 1991-1994, Digital Equipment Corporation and
the Massachusetts Institute of Technology.
.SH AUTHORS
Digital Cambridge Research Lab

