.TH AF 1 "Release 1"  "AF Version 3"
.SH NAME
AF - a network-transparent audio server and client library for
networked audio devices.
.SH SYNOPSIS
.PP
The AF audio server
is a network transparent  system developed at Digital CRL
for using LoFi audio hardware in a distributed environment.
.SH "CONNECTION NAME"
.PP
From the user's prospective, every AF server has 
an \fIaudio connection\fP of the form:
.sp
.ce 1
\fIhostname:portOffset\fP
.sp
This information is used by the application to determine how it should
connect to the server.
.TP 8
.I hostname
The \fIhostname\fP specifies the name of the machine to which the 
audio device is physically connected.  
.TP 8
.I portOffset
The \fIportOffset\fP is used to identify
the audio server's port on \fIhostname\fP.
For example, to run multiple audio servers on a given host 
simultaneously, you need to select a unique \fIportOffset\fP
for each invocation of an audio server.
.PP
If the connection name to an audio server is not specified, 
then the environment variables \fIAUDIOFILE\fP or \fIDISPLAY\fP 
will be used.
.SH "ACCESS CONTROL"
The sample server provides two types of access control:  an authorization
protocol which provides a list of ``magic cookies'' clients can send to
request access, and a list of hosts from which connections are always
accepted.  
.SH BUGS
If you encounter a \fBrepeatable\fP bug, please 
submit a problem report to () and include the source code if possible.
.SH "SEE ALSO"
.PP
Aaxp(1), Amaxine(1), Alofi(1), Ajv(1), Amsb(1), Asgi(1), Asparc(1), 
Amsb(1), Aj300(1),
aplay(1), arecord(1), ahs(1),
apass(1), aset(1), abrowse(1), afft(1), ahost(1), aphone(1), aprop(1),
axset(1), xpow(1), afxctl(1), aname2num(1), alsatoms(1), aevents(1), abob(1)
.SH COPYRIGHT
.PP
Software in this distribution of the AF Audio Server is covered 
by copyrights.  See the COPYRIGHTS file in the root directory of the
source kit.
.PP
What you do with applications you develop is your buisness; if you wish
to contribute code to this distribution see below.
.PP
In order to contribute software to the AF distribution, we suggest
following the model of the X Window System.
The following is the guide lines from that distribution.  Other terms will
make it unlikely that we will include a contribution on subsequent releases;
we do not wish to spend our time with lawyers on a case by case basis.
.PP
The MIT distribution of the X Window System is publicly available, but is NOT
in the public domain.  The difference is that copyrights granting rights for
unrestricted use and redistribution have been placed on all of the software to
identify its authors.  You are allowed and encouraged to take this software and
build commerical products.
.PP
Individuals or organizations wishing to contribute software to the public
releases should use a copyright notice that is no more restrictive than 
the sample given below.  In particular, 
.IP "o" 8
Do not place any restictions on what can be done with this software
(this includes using the GNU "copyleft").
.IP "o" 8
Do not include the words "All rights reserved" unless you have had a 
lawyer verify that you have also explicitly given away all of the 
necessary rights shown in the samples.
.IP "o" 8
Spell out the word "Copyright"; the phrase "(c)" is NOT a legal
alternative to the c-in-circle symbol.
.IP "o" 8
Put at least a one-line copyright at the top of EVERY source file, if
not the full copyright.  Also, the copyright line or full notice MUST
physically appear in each file.  Using the preprocessor to #include the
copyright from some other file has no legal meaning (it can be used to
incorporate common strings into the binary, but has no effect on the
status of the source code).
.IP "o" 8
Things that are copyrighted are, by definition, not in the public
domain.
.IP "o" 8
A copyright notice similar to the following is strongly recommended (replacing
MIT with your organization's name and putting your name and address at the
bottom).
.PP
.DS L
/*
 * Copyright 1989 Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, distribute, and sell 
 * this software and its documentation for any purpose is 
 * hereby granted without fee, provided that the above copyright 
 * notice appear in all copies and that both that copyright notice 
 * and this permission notice appear in supporting documentation, 
 * and that the name of M.I.T. not be used in advertising or 
 * publicity pertaining to distribution of the software without 
 * specific, written prior permission.  M.I.T. makes no representations 
 * about the suitability of this software for any purpose.  
 * It is provided "as is" without express or implied warranty. 
 *
 * M.I.T. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, 
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, 
 * IN NO EVENT SHALL M.I.T. BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM 
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 *
 * Author:  Your Name, Name of your organization
 */
.DE
.PP
Also, see the COPYRIGHTS file.
.sp
Copyright 1991-1994, Digital Equipment Corporation and
the Massachusetts Institute of Technology.
.SH AUTHORS
Digital Cambridge Research Lab

